# -*- perl -*-

# Copyright (c) 2002 by Jeff Weisberg
# Author: Jeff Weisberg <argus @ tcp4me.com>
# Date: 2002-Apr-02 13:52 (EST)
# Function: control channel listener
#
# $Id: CListen_INET.pm,v 1.3 2002/10/20 22:32:13 jaw Exp $

# this file is for debugging only, it should not be used
# in production--there is no access control mechanism

package CListen_INET;
use Fcntl;
use Socket;
@ISA = qw(BaseIO);

# The open ear of youth doth always listen;
#	-- Shakespeare King Richard II

$doc = {
    package => __PACKAGE__,
    file    => __FILE__,
    isa     => [@ISA],
    methods => {
    },
    fields  => {
    },
};

sub new {
    my $class = shift;
    my $port  = shift;
    my( $me, $fh, $i, $p );

    $me = {};
    bless $me, $class;
    $me->{type} = 'CListen_I';
    $me->{fd} = $fh = BaseIO::anon_fh();

    socket($fh, PF_INET, SOCK_STREAM, getprotobyname('tcp'));
    setsockopt($fh, SOL_SOCKET, SO_REUSEADDR, 1);
    $i = bind($fh, sockaddr_in($port, INADDR_ANY));
    return ::warning( "Cannot bind Control Port tcp/$port: $!" )
	unless $i;
	
    listen( $fh, 10 );
    $me->wantread(1);
    $me->wantwrit(0);
    $me->settimeout(0);
    $me->baseio_init();

    $me;
}

# becomes readable if someone connects - create a new control channel
sub readable {
    my $me = shift;
    my( $fh, $nfh, $c, $i );

    $fh  = $me->{fd};
    $nfh = BaseIO::anon_fh();
    accept( $nfh, $fh );
    
    $c = Control->new( $nfh, ::inet_ntoa( (sockaddr_in(getpeername($nfh)))[1] ) );

}

################################################################
# class global init
################################################################
Doc::register( $doc );

1;
