# -*- perl -*-

# Copyright (c) 2002 by Jeff Weisberg
# Author: Jeff Weisberg <jaw @ tcp4me.com>
# Date: 2002-Oct-22 16:06 (EDT)
# Function: Notification Method base class
#
# $Id: NotMe.pm,v 1.2 2002/10/25 19:59:04 jaw Exp $

package NotMe;
use Sendmail;
use Qpage;

# but I seek my master, and my master seeks not me
#   -- Shakespeare, Two Gentlemen of Verona

%methods;

sub transmit {
    my $note = shift;
    my $meth = shift;
    my $addr = shift;
    my $msg  = shift;
    my $extra= shift;

    # Though this be madness, yet there is method in 't.
    #   -- Shakespeare, Hamlet
    if( $methods{$meth} ){
	$methods{$meth}->($note, $meth, $addr, $msg, $extra);
    }else{
	$note->loggit( $addr, "unknown method ($meth) - cannot send", 1 );
    }
}

# null notification method
sub null {}
# for debugging
sub nlog {
    my $note = shift;
    my $meth = shift;
    my $addr = shift;
    my $msg  = shift;
    my $extra= shift;

    ::loggit( "(log) NOTIFY: $msg $extra" );
}


$methods{null} = \&null;
$methods{log}  = \&nlog;

1;
